// THIS FILE IS AUTOMATICALLY GENERATED. DO NOT EDIT.

// Package codedeploy provides a client for AWS CodeDeploy.
package codedeploy

import (
	"sync"
	"time"

	"github.com/awslabs/aws-sdk-go/aws"
)

var oprw sync.Mutex

// BatchGetApplicationsRequest generates a request for the BatchGetApplications operation.
func (c *CodeDeploy) BatchGetApplicationsRequest(input *BatchGetApplicationsInput) (req *aws.Request, output *BatchGetApplicationsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opBatchGetApplications == nil {
		opBatchGetApplications = &aws.Operation{
			Name:       "BatchGetApplications",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &BatchGetApplicationsInput{}
	}

	req = c.newRequest(opBatchGetApplications, input, output)
	output = &BatchGetApplicationsOutput{}
	req.Data = output
	return
}

// Gets information about one or more applications.
func (c *CodeDeploy) BatchGetApplications(input *BatchGetApplicationsInput) (*BatchGetApplicationsOutput, error) {
	req, out := c.BatchGetApplicationsRequest(input)
	err := req.Send()
	return out, err
}

var opBatchGetApplications *aws.Operation

// BatchGetDeploymentsRequest generates a request for the BatchGetDeployments operation.
func (c *CodeDeploy) BatchGetDeploymentsRequest(input *BatchGetDeploymentsInput) (req *aws.Request, output *BatchGetDeploymentsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opBatchGetDeployments == nil {
		opBatchGetDeployments = &aws.Operation{
			Name:       "BatchGetDeployments",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &BatchGetDeploymentsInput{}
	}

	req = c.newRequest(opBatchGetDeployments, input, output)
	output = &BatchGetDeploymentsOutput{}
	req.Data = output
	return
}

// Gets information about one or more deployments.
func (c *CodeDeploy) BatchGetDeployments(input *BatchGetDeploymentsInput) (*BatchGetDeploymentsOutput, error) {
	req, out := c.BatchGetDeploymentsRequest(input)
	err := req.Send()
	return out, err
}

var opBatchGetDeployments *aws.Operation

// CreateApplicationRequest generates a request for the CreateApplication operation.
func (c *CodeDeploy) CreateApplicationRequest(input *CreateApplicationInput) (req *aws.Request, output *CreateApplicationOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opCreateApplication == nil {
		opCreateApplication = &aws.Operation{
			Name:       "CreateApplication",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &CreateApplicationInput{}
	}

	req = c.newRequest(opCreateApplication, input, output)
	output = &CreateApplicationOutput{}
	req.Data = output
	return
}

// Creates a new application.
func (c *CodeDeploy) CreateApplication(input *CreateApplicationInput) (*CreateApplicationOutput, error) {
	req, out := c.CreateApplicationRequest(input)
	err := req.Send()
	return out, err
}

var opCreateApplication *aws.Operation

// CreateDeploymentRequest generates a request for the CreateDeployment operation.
func (c *CodeDeploy) CreateDeploymentRequest(input *CreateDeploymentInput) (req *aws.Request, output *CreateDeploymentOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opCreateDeployment == nil {
		opCreateDeployment = &aws.Operation{
			Name:       "CreateDeployment",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &CreateDeploymentInput{}
	}

	req = c.newRequest(opCreateDeployment, input, output)
	output = &CreateDeploymentOutput{}
	req.Data = output
	return
}

// Deploys an application revision to the specified deployment group.
func (c *CodeDeploy) CreateDeployment(input *CreateDeploymentInput) (*CreateDeploymentOutput, error) {
	req, out := c.CreateDeploymentRequest(input)
	err := req.Send()
	return out, err
}

var opCreateDeployment *aws.Operation

// CreateDeploymentConfigRequest generates a request for the CreateDeploymentConfig operation.
func (c *CodeDeploy) CreateDeploymentConfigRequest(input *CreateDeploymentConfigInput) (req *aws.Request, output *CreateDeploymentConfigOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opCreateDeploymentConfig == nil {
		opCreateDeploymentConfig = &aws.Operation{
			Name:       "CreateDeploymentConfig",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &CreateDeploymentConfigInput{}
	}

	req = c.newRequest(opCreateDeploymentConfig, input, output)
	output = &CreateDeploymentConfigOutput{}
	req.Data = output
	return
}

// Creates a new deployment configuration.
func (c *CodeDeploy) CreateDeploymentConfig(input *CreateDeploymentConfigInput) (*CreateDeploymentConfigOutput, error) {
	req, out := c.CreateDeploymentConfigRequest(input)
	err := req.Send()
	return out, err
}

var opCreateDeploymentConfig *aws.Operation

// CreateDeploymentGroupRequest generates a request for the CreateDeploymentGroup operation.
func (c *CodeDeploy) CreateDeploymentGroupRequest(input *CreateDeploymentGroupInput) (req *aws.Request, output *CreateDeploymentGroupOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opCreateDeploymentGroup == nil {
		opCreateDeploymentGroup = &aws.Operation{
			Name:       "CreateDeploymentGroup",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &CreateDeploymentGroupInput{}
	}

	req = c.newRequest(opCreateDeploymentGroup, input, output)
	output = &CreateDeploymentGroupOutput{}
	req.Data = output
	return
}

// Creates a new deployment group for application revisions to be deployed to.
func (c *CodeDeploy) CreateDeploymentGroup(input *CreateDeploymentGroupInput) (*CreateDeploymentGroupOutput, error) {
	req, out := c.CreateDeploymentGroupRequest(input)
	err := req.Send()
	return out, err
}

var opCreateDeploymentGroup *aws.Operation

// DeleteApplicationRequest generates a request for the DeleteApplication operation.
func (c *CodeDeploy) DeleteApplicationRequest(input *DeleteApplicationInput) (req *aws.Request, output *DeleteApplicationOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opDeleteApplication == nil {
		opDeleteApplication = &aws.Operation{
			Name:       "DeleteApplication",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &DeleteApplicationInput{}
	}

	req = c.newRequest(opDeleteApplication, input, output)
	output = &DeleteApplicationOutput{}
	req.Data = output
	return
}

// Deletes an application.
func (c *CodeDeploy) DeleteApplication(input *DeleteApplicationInput) (*DeleteApplicationOutput, error) {
	req, out := c.DeleteApplicationRequest(input)
	err := req.Send()
	return out, err
}

var opDeleteApplication *aws.Operation

// DeleteDeploymentConfigRequest generates a request for the DeleteDeploymentConfig operation.
func (c *CodeDeploy) DeleteDeploymentConfigRequest(input *DeleteDeploymentConfigInput) (req *aws.Request, output *DeleteDeploymentConfigOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opDeleteDeploymentConfig == nil {
		opDeleteDeploymentConfig = &aws.Operation{
			Name:       "DeleteDeploymentConfig",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &DeleteDeploymentConfigInput{}
	}

	req = c.newRequest(opDeleteDeploymentConfig, input, output)
	output = &DeleteDeploymentConfigOutput{}
	req.Data = output
	return
}

// Deletes a deployment configuration.
//
// A deployment configuration cannot be deleted if it is currently in use.
// Also, predefined configurations cannot be deleted.
func (c *CodeDeploy) DeleteDeploymentConfig(input *DeleteDeploymentConfigInput) (*DeleteDeploymentConfigOutput, error) {
	req, out := c.DeleteDeploymentConfigRequest(input)
	err := req.Send()
	return out, err
}

var opDeleteDeploymentConfig *aws.Operation

// DeleteDeploymentGroupRequest generates a request for the DeleteDeploymentGroup operation.
func (c *CodeDeploy) DeleteDeploymentGroupRequest(input *DeleteDeploymentGroupInput) (req *aws.Request, output *DeleteDeploymentGroupOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opDeleteDeploymentGroup == nil {
		opDeleteDeploymentGroup = &aws.Operation{
			Name:       "DeleteDeploymentGroup",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &DeleteDeploymentGroupInput{}
	}

	req = c.newRequest(opDeleteDeploymentGroup, input, output)
	output = &DeleteDeploymentGroupOutput{}
	req.Data = output
	return
}

// Deletes a deployment group.
func (c *CodeDeploy) DeleteDeploymentGroup(input *DeleteDeploymentGroupInput) (*DeleteDeploymentGroupOutput, error) {
	req, out := c.DeleteDeploymentGroupRequest(input)
	err := req.Send()
	return out, err
}

var opDeleteDeploymentGroup *aws.Operation

// GetApplicationRequest generates a request for the GetApplication operation.
func (c *CodeDeploy) GetApplicationRequest(input *GetApplicationInput) (req *aws.Request, output *GetApplicationOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opGetApplication == nil {
		opGetApplication = &aws.Operation{
			Name:       "GetApplication",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &GetApplicationInput{}
	}

	req = c.newRequest(opGetApplication, input, output)
	output = &GetApplicationOutput{}
	req.Data = output
	return
}

// Gets information about an application.
func (c *CodeDeploy) GetApplication(input *GetApplicationInput) (*GetApplicationOutput, error) {
	req, out := c.GetApplicationRequest(input)
	err := req.Send()
	return out, err
}

var opGetApplication *aws.Operation

// GetApplicationRevisionRequest generates a request for the GetApplicationRevision operation.
func (c *CodeDeploy) GetApplicationRevisionRequest(input *GetApplicationRevisionInput) (req *aws.Request, output *GetApplicationRevisionOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opGetApplicationRevision == nil {
		opGetApplicationRevision = &aws.Operation{
			Name:       "GetApplicationRevision",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &GetApplicationRevisionInput{}
	}

	req = c.newRequest(opGetApplicationRevision, input, output)
	output = &GetApplicationRevisionOutput{}
	req.Data = output
	return
}

// Gets information about an application revision.
func (c *CodeDeploy) GetApplicationRevision(input *GetApplicationRevisionInput) (*GetApplicationRevisionOutput, error) {
	req, out := c.GetApplicationRevisionRequest(input)
	err := req.Send()
	return out, err
}

var opGetApplicationRevision *aws.Operation

// GetDeploymentRequest generates a request for the GetDeployment operation.
func (c *CodeDeploy) GetDeploymentRequest(input *GetDeploymentInput) (req *aws.Request, output *GetDeploymentOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opGetDeployment == nil {
		opGetDeployment = &aws.Operation{
			Name:       "GetDeployment",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &GetDeploymentInput{}
	}

	req = c.newRequest(opGetDeployment, input, output)
	output = &GetDeploymentOutput{}
	req.Data = output
	return
}

// Gets information about a deployment.
func (c *CodeDeploy) GetDeployment(input *GetDeploymentInput) (*GetDeploymentOutput, error) {
	req, out := c.GetDeploymentRequest(input)
	err := req.Send()
	return out, err
}

var opGetDeployment *aws.Operation

// GetDeploymentConfigRequest generates a request for the GetDeploymentConfig operation.
func (c *CodeDeploy) GetDeploymentConfigRequest(input *GetDeploymentConfigInput) (req *aws.Request, output *GetDeploymentConfigOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opGetDeploymentConfig == nil {
		opGetDeploymentConfig = &aws.Operation{
			Name:       "GetDeploymentConfig",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &GetDeploymentConfigInput{}
	}

	req = c.newRequest(opGetDeploymentConfig, input, output)
	output = &GetDeploymentConfigOutput{}
	req.Data = output
	return
}

// Gets information about a deployment configuration.
func (c *CodeDeploy) GetDeploymentConfig(input *GetDeploymentConfigInput) (*GetDeploymentConfigOutput, error) {
	req, out := c.GetDeploymentConfigRequest(input)
	err := req.Send()
	return out, err
}

var opGetDeploymentConfig *aws.Operation

// GetDeploymentGroupRequest generates a request for the GetDeploymentGroup operation.
func (c *CodeDeploy) GetDeploymentGroupRequest(input *GetDeploymentGroupInput) (req *aws.Request, output *GetDeploymentGroupOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opGetDeploymentGroup == nil {
		opGetDeploymentGroup = &aws.Operation{
			Name:       "GetDeploymentGroup",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &GetDeploymentGroupInput{}
	}

	req = c.newRequest(opGetDeploymentGroup, input, output)
	output = &GetDeploymentGroupOutput{}
	req.Data = output
	return
}

// Gets information about a deployment group.
func (c *CodeDeploy) GetDeploymentGroup(input *GetDeploymentGroupInput) (*GetDeploymentGroupOutput, error) {
	req, out := c.GetDeploymentGroupRequest(input)
	err := req.Send()
	return out, err
}

var opGetDeploymentGroup *aws.Operation

// GetDeploymentInstanceRequest generates a request for the GetDeploymentInstance operation.
func (c *CodeDeploy) GetDeploymentInstanceRequest(input *GetDeploymentInstanceInput) (req *aws.Request, output *GetDeploymentInstanceOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opGetDeploymentInstance == nil {
		opGetDeploymentInstance = &aws.Operation{
			Name:       "GetDeploymentInstance",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &GetDeploymentInstanceInput{}
	}

	req = c.newRequest(opGetDeploymentInstance, input, output)
	output = &GetDeploymentInstanceOutput{}
	req.Data = output
	return
}

// Gets information about an Amazon EC2 instance as part of a deployment.
func (c *CodeDeploy) GetDeploymentInstance(input *GetDeploymentInstanceInput) (*GetDeploymentInstanceOutput, error) {
	req, out := c.GetDeploymentInstanceRequest(input)
	err := req.Send()
	return out, err
}

var opGetDeploymentInstance *aws.Operation

// ListApplicationRevisionsRequest generates a request for the ListApplicationRevisions operation.
func (c *CodeDeploy) ListApplicationRevisionsRequest(input *ListApplicationRevisionsInput) (req *aws.Request, output *ListApplicationRevisionsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opListApplicationRevisions == nil {
		opListApplicationRevisions = &aws.Operation{
			Name:       "ListApplicationRevisions",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &ListApplicationRevisionsInput{}
	}

	req = c.newRequest(opListApplicationRevisions, input, output)
	output = &ListApplicationRevisionsOutput{}
	req.Data = output
	return
}

// Lists information about revisions for an application.
func (c *CodeDeploy) ListApplicationRevisions(input *ListApplicationRevisionsInput) (*ListApplicationRevisionsOutput, error) {
	req, out := c.ListApplicationRevisionsRequest(input)
	err := req.Send()
	return out, err
}

var opListApplicationRevisions *aws.Operation

// ListApplicationsRequest generates a request for the ListApplications operation.
func (c *CodeDeploy) ListApplicationsRequest(input *ListApplicationsInput) (req *aws.Request, output *ListApplicationsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opListApplications == nil {
		opListApplications = &aws.Operation{
			Name:       "ListApplications",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &ListApplicationsInput{}
	}

	req = c.newRequest(opListApplications, input, output)
	output = &ListApplicationsOutput{}
	req.Data = output
	return
}

// Lists the applications registered within the AWS user account.
func (c *CodeDeploy) ListApplications(input *ListApplicationsInput) (*ListApplicationsOutput, error) {
	req, out := c.ListApplicationsRequest(input)
	err := req.Send()
	return out, err
}

var opListApplications *aws.Operation

// ListDeploymentConfigsRequest generates a request for the ListDeploymentConfigs operation.
func (c *CodeDeploy) ListDeploymentConfigsRequest(input *ListDeploymentConfigsInput) (req *aws.Request, output *ListDeploymentConfigsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opListDeploymentConfigs == nil {
		opListDeploymentConfigs = &aws.Operation{
			Name:       "ListDeploymentConfigs",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &ListDeploymentConfigsInput{}
	}

	req = c.newRequest(opListDeploymentConfigs, input, output)
	output = &ListDeploymentConfigsOutput{}
	req.Data = output
	return
}

// Lists the deployment configurations within the AWS user account.
func (c *CodeDeploy) ListDeploymentConfigs(input *ListDeploymentConfigsInput) (*ListDeploymentConfigsOutput, error) {
	req, out := c.ListDeploymentConfigsRequest(input)
	err := req.Send()
	return out, err
}

var opListDeploymentConfigs *aws.Operation

// ListDeploymentGroupsRequest generates a request for the ListDeploymentGroups operation.
func (c *CodeDeploy) ListDeploymentGroupsRequest(input *ListDeploymentGroupsInput) (req *aws.Request, output *ListDeploymentGroupsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opListDeploymentGroups == nil {
		opListDeploymentGroups = &aws.Operation{
			Name:       "ListDeploymentGroups",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &ListDeploymentGroupsInput{}
	}

	req = c.newRequest(opListDeploymentGroups, input, output)
	output = &ListDeploymentGroupsOutput{}
	req.Data = output
	return
}

// Lists the deployment groups for an application registered within the AWS
// user account.
func (c *CodeDeploy) ListDeploymentGroups(input *ListDeploymentGroupsInput) (*ListDeploymentGroupsOutput, error) {
	req, out := c.ListDeploymentGroupsRequest(input)
	err := req.Send()
	return out, err
}

var opListDeploymentGroups *aws.Operation

// ListDeploymentInstancesRequest generates a request for the ListDeploymentInstances operation.
func (c *CodeDeploy) ListDeploymentInstancesRequest(input *ListDeploymentInstancesInput) (req *aws.Request, output *ListDeploymentInstancesOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opListDeploymentInstances == nil {
		opListDeploymentInstances = &aws.Operation{
			Name:       "ListDeploymentInstances",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &ListDeploymentInstancesInput{}
	}

	req = c.newRequest(opListDeploymentInstances, input, output)
	output = &ListDeploymentInstancesOutput{}
	req.Data = output
	return
}

// Lists the Amazon EC2 instances for a deployment within the AWS user account.
func (c *CodeDeploy) ListDeploymentInstances(input *ListDeploymentInstancesInput) (*ListDeploymentInstancesOutput, error) {
	req, out := c.ListDeploymentInstancesRequest(input)
	err := req.Send()
	return out, err
}

var opListDeploymentInstances *aws.Operation

// ListDeploymentsRequest generates a request for the ListDeployments operation.
func (c *CodeDeploy) ListDeploymentsRequest(input *ListDeploymentsInput) (req *aws.Request, output *ListDeploymentsOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opListDeployments == nil {
		opListDeployments = &aws.Operation{
			Name:       "ListDeployments",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &ListDeploymentsInput{}
	}

	req = c.newRequest(opListDeployments, input, output)
	output = &ListDeploymentsOutput{}
	req.Data = output
	return
}

// Lists the deployments under a deployment group for an application registered
// within the AWS user account.
func (c *CodeDeploy) ListDeployments(input *ListDeploymentsInput) (*ListDeploymentsOutput, error) {
	req, out := c.ListDeploymentsRequest(input)
	err := req.Send()
	return out, err
}

var opListDeployments *aws.Operation

// RegisterApplicationRevisionRequest generates a request for the RegisterApplicationRevision operation.
func (c *CodeDeploy) RegisterApplicationRevisionRequest(input *RegisterApplicationRevisionInput) (req *aws.Request, output *RegisterApplicationRevisionOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opRegisterApplicationRevision == nil {
		opRegisterApplicationRevision = &aws.Operation{
			Name:       "RegisterApplicationRevision",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &RegisterApplicationRevisionInput{}
	}

	req = c.newRequest(opRegisterApplicationRevision, input, output)
	output = &RegisterApplicationRevisionOutput{}
	req.Data = output
	return
}

// Registers with AWS CodeDeploy a revision for the specified application.
func (c *CodeDeploy) RegisterApplicationRevision(input *RegisterApplicationRevisionInput) (*RegisterApplicationRevisionOutput, error) {
	req, out := c.RegisterApplicationRevisionRequest(input)
	err := req.Send()
	return out, err
}

var opRegisterApplicationRevision *aws.Operation

// StopDeploymentRequest generates a request for the StopDeployment operation.
func (c *CodeDeploy) StopDeploymentRequest(input *StopDeploymentInput) (req *aws.Request, output *StopDeploymentOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opStopDeployment == nil {
		opStopDeployment = &aws.Operation{
			Name:       "StopDeployment",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &StopDeploymentInput{}
	}

	req = c.newRequest(opStopDeployment, input, output)
	output = &StopDeploymentOutput{}
	req.Data = output
	return
}

// Attempts to stop an ongoing deployment.
func (c *CodeDeploy) StopDeployment(input *StopDeploymentInput) (*StopDeploymentOutput, error) {
	req, out := c.StopDeploymentRequest(input)
	err := req.Send()
	return out, err
}

var opStopDeployment *aws.Operation

// UpdateApplicationRequest generates a request for the UpdateApplication operation.
func (c *CodeDeploy) UpdateApplicationRequest(input *UpdateApplicationInput) (req *aws.Request, output *UpdateApplicationOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opUpdateApplication == nil {
		opUpdateApplication = &aws.Operation{
			Name:       "UpdateApplication",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &UpdateApplicationInput{}
	}

	req = c.newRequest(opUpdateApplication, input, output)
	output = &UpdateApplicationOutput{}
	req.Data = output
	return
}

// Changes an existing application's name.
func (c *CodeDeploy) UpdateApplication(input *UpdateApplicationInput) (*UpdateApplicationOutput, error) {
	req, out := c.UpdateApplicationRequest(input)
	err := req.Send()
	return out, err
}

var opUpdateApplication *aws.Operation

// UpdateDeploymentGroupRequest generates a request for the UpdateDeploymentGroup operation.
func (c *CodeDeploy) UpdateDeploymentGroupRequest(input *UpdateDeploymentGroupInput) (req *aws.Request, output *UpdateDeploymentGroupOutput) {
	oprw.Lock()
	defer oprw.Unlock()

	if opUpdateDeploymentGroup == nil {
		opUpdateDeploymentGroup = &aws.Operation{
			Name:       "UpdateDeploymentGroup",
			HTTPMethod: "POST",
			HTTPPath:   "/",
		}
	}

	if input == nil {
		input = &UpdateDeploymentGroupInput{}
	}

	req = c.newRequest(opUpdateDeploymentGroup, input, output)
	output = &UpdateDeploymentGroupOutput{}
	req.Data = output
	return
}

// Changes information about an existing deployment group.
func (c *CodeDeploy) UpdateDeploymentGroup(input *UpdateDeploymentGroupInput) (*UpdateDeploymentGroupOutput, error) {
	req, out := c.UpdateDeploymentGroupRequest(input)
	err := req.Send()
	return out, err
}

var opUpdateDeploymentGroup *aws.Operation

// Information about an application.
type ApplicationInfo struct {
	// The application ID.
	ApplicationID *string `locationName:"applicationId" type:"string"`

	// The application name.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// The time that the application was created.
	CreateTime *time.Time `locationName:"createTime" type:"timestamp" timestampFormat:"unix"`

	// True if the user has authenticated with GitHub for the specified application;
	// otherwise, false.
	LinkedToGitHub *bool `locationName:"linkedToGitHub" type:"boolean"`

	metadataApplicationInfo `json:"-" xml:"-"`
}

type metadataApplicationInfo struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about an Auto Scaling group.
type AutoScalingGroup struct {
	// An Auto Scaling lifecycle event hook name.
	Hook *string `locationName:"hook" type:"string"`

	// The Auto Scaling group name.
	Name *string `locationName:"name" type:"string"`

	metadataAutoScalingGroup `json:"-" xml:"-"`
}

type metadataAutoScalingGroup struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a batch get applications operation.
type BatchGetApplicationsInput struct {
	// A list of application names, with multiple application names separated by
	// spaces.
	ApplicationNames []*string `locationName:"applicationNames" type:"list"`

	metadataBatchGetApplicationsInput `json:"-" xml:"-"`
}

type metadataBatchGetApplicationsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a batch get applications operation.
type BatchGetApplicationsOutput struct {
	// Information about the applications.
	ApplicationsInfo []*ApplicationInfo `locationName:"applicationsInfo" type:"list"`

	metadataBatchGetApplicationsOutput `json:"-" xml:"-"`
}

type metadataBatchGetApplicationsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a batch get deployments operation.
type BatchGetDeploymentsInput struct {
	// A list of deployment IDs, with multiple deployment IDs separated by spaces.
	DeploymentIDs []*string `locationName:"deploymentIds" type:"list"`

	metadataBatchGetDeploymentsInput `json:"-" xml:"-"`
}

type metadataBatchGetDeploymentsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a batch get deployments operation.
type BatchGetDeploymentsOutput struct {
	// Information about the deployments.
	DeploymentsInfo []*DeploymentInfo `locationName:"deploymentsInfo" type:"list"`

	metadataBatchGetDeploymentsOutput `json:"-" xml:"-"`
}

type metadataBatchGetDeploymentsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a create application operation.
type CreateApplicationInput struct {
	// The name of the application. This name must be unique within the AWS user
	// account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	metadataCreateApplicationInput `json:"-" xml:"-"`
}

type metadataCreateApplicationInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a create application operation.
type CreateApplicationOutput struct {
	// A unique application ID.
	ApplicationID *string `locationName:"applicationId" type:"string"`

	metadataCreateApplicationOutput `json:"-" xml:"-"`
}

type metadataCreateApplicationOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a create deployment configuration operation.
type CreateDeploymentConfigInput struct {
	// The name of the deployment configuration to create.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string" required:"true"`

	// The minimum number of healthy instances that should be available at any time
	// during the deployment. There are two parameters expected in the input: type
	// and value.
	//
	// The type parameter takes either of the following values:
	//
	//  HOST_COUNT: The value parameter represents the minimum number of healthy
	// instances, as an absolute value. FLEET_PERCENT: The value parameter represents
	// the minimum number of healthy instances, as a percentage of the total number
	// of instances in the deployment. If you specify FLEET_PERCENT, then at the
	// start of the deployment AWS CodeDeploy converts the percentage to the equivalent
	// number of instances and rounds fractional instances up.  The value parameter
	// takes an integer.
	//
	// For example, to set a minimum of 95% healthy instances, specify a type of
	// FLEET_PERCENT and a value of 95.
	MinimumHealthyHosts *MinimumHealthyHosts `locationName:"minimumHealthyHosts" type:"structure"`

	metadataCreateDeploymentConfigInput `json:"-" xml:"-"`
}

type metadataCreateDeploymentConfigInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a create deployment configuration operation.
type CreateDeploymentConfigOutput struct {
	// A unique deployment configuration ID.
	DeploymentConfigID *string `locationName:"deploymentConfigId" type:"string"`

	metadataCreateDeploymentConfigOutput `json:"-" xml:"-"`
}

type metadataCreateDeploymentConfigOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a create deployment group operation.
type CreateDeploymentGroupInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// A list of associated Auto Scaling groups.
	AutoScalingGroups []*string `locationName:"autoScalingGroups" type:"list"`

	// If specified, the deployment configuration name must be one of the predefined
	// values, or it can be a custom deployment configuration:
	//
	//  CodeDeployDefault.AllAtOnce deploys an application revision to up to all
	// of the Amazon EC2 instances at once. The overall deployment succeeds if the
	// application revision deploys to at least one of the instances. The overall
	// deployment fails after the application revision fails to deploy to all of
	// the instances. For example, for 9 instances, deploy to up to all 9 instances
	// at once. The overall deployment succeeds if any of the 9 instances is successfully
	// deployed to, and it fails if all 9 instances fail to be deployed to. CodeDeployDefault.HalfAtATime
	// deploys to up to half of the instances at a time (with fractions rounded
	// down). The overall deployment succeeds if the application revision deploys
	// to at least half of the instances (with fractions rounded up); otherwise,
	// the deployment fails. For example, for 9 instances, deploy to up to 4 instances
	// at a time. The overall deployment succeeds if 5 or more instances are successfully
	// deployed to; otherwise, the deployment fails. Note that the deployment may
	// successfully deploy to some instances, even if the overall deployment fails.
	// CodeDeployDefault.OneAtATime deploys the application revision to only one
	// of the instances at a time. The overall deployment succeeds if the application
	// revision deploys to all of the instances. The overall deployment fails after
	// the application revision first fails to deploy to any one instance. For example,
	// for 9 instances, deploy to one instance at a time. The overall deployment
	// succeeds if all 9 instances are successfully deployed to, and it fails if
	// any of one of the 9 instances fail to be deployed to. Note that the deployment
	// may successfully deploy to some instances, even if the overall deployment
	// fails. This is the default deployment configuration if a configuration isn't
	// specified for either the deployment or the deployment group.  To create a
	// custom deployment configuration, call the create deployment configuration
	// operation.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string"`

	// The name of an existing deployment group for the specified application.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string" required:"true"`

	// The Amazon EC2 tags to filter on.
	EC2TagFilters []*EC2TagFilter `locationName:"ec2TagFilters" type:"list"`

	// A service role ARN that allows AWS CodeDeploy to act on the user's behalf
	// when interacting with AWS services.
	ServiceRoleARN *string `locationName:"serviceRoleArn" type:"string"`

	metadataCreateDeploymentGroupInput `json:"-" xml:"-"`
}

type metadataCreateDeploymentGroupInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a create deployment group operation.
type CreateDeploymentGroupOutput struct {
	// A unique deployment group ID.
	DeploymentGroupID *string `locationName:"deploymentGroupId" type:"string"`

	metadataCreateDeploymentGroupOutput `json:"-" xml:"-"`
}

type metadataCreateDeploymentGroupOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a create deployment operation.
type CreateDeploymentInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// The name of an existing deployment configuration within the AWS user account.
	//
	// If not specified, the value configured in the deployment group will be used
	// as the default. If the deployment group does not have a deployment configuration
	// associated with it, then CodeDeployDefault.OneAtATime will be used by default.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string"`

	// The deployment group's name.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string"`

	// A comment about the deployment.
	Description *string `locationName:"description" type:"string"`

	// If set to true, then if the deployment causes the ApplicationStop deployment
	// lifecycle event to fail to a specific instance, the deployment will not be
	// considered to have failed to that instance at that point and will continue
	// on to the BeforeInstall deployment lifecycle event.
	//
	// If set to false or not specified, then if the deployment causes the ApplicationStop
	// deployment lifecycle event to fail to a specific instance, the deployment
	// will stop to that instance, and the deployment to that instance will be considered
	// to have failed.
	IgnoreApplicationStopFailures *bool `locationName:"ignoreApplicationStopFailures" type:"boolean"`

	// The type of revision to deploy, along with information about the revision's
	// location.
	Revision *RevisionLocation `locationName:"revision" type:"structure"`

	metadataCreateDeploymentInput `json:"-" xml:"-"`
}

type metadataCreateDeploymentInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a create deployment operation.
type CreateDeploymentOutput struct {
	// A unique deployment ID.
	DeploymentID *string `locationName:"deploymentId" type:"string"`

	metadataCreateDeploymentOutput `json:"-" xml:"-"`
}

type metadataCreateDeploymentOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a delete application operation.
type DeleteApplicationInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	metadataDeleteApplicationInput `json:"-" xml:"-"`
}

type metadataDeleteApplicationInput struct {
	SDKShapeTraits bool `type:"structure"`
}

type DeleteApplicationOutput struct {
	metadataDeleteApplicationOutput `json:"-" xml:"-"`
}

type metadataDeleteApplicationOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a delete deployment configuration operation.
type DeleteDeploymentConfigInput struct {
	// The name of an existing deployment configuration within the AWS user account.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string" required:"true"`

	metadataDeleteDeploymentConfigInput `json:"-" xml:"-"`
}

type metadataDeleteDeploymentConfigInput struct {
	SDKShapeTraits bool `type:"structure"`
}

type DeleteDeploymentConfigOutput struct {
	metadataDeleteDeploymentConfigOutput `json:"-" xml:"-"`
}

type metadataDeleteDeploymentConfigOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a delete deployment group operation.
type DeleteDeploymentGroupInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// The name of an existing deployment group for the specified application.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string" required:"true"`

	metadataDeleteDeploymentGroupInput `json:"-" xml:"-"`
}

type metadataDeleteDeploymentGroupInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a delete deployment group operation.
type DeleteDeploymentGroupOutput struct {
	// If the output contains no data, and the corresponding deployment group contained
	// at least one Auto Scaling group, AWS CodeDeploy successfully removed all
	// corresponding Auto Scaling lifecycle event hooks from the instances in the
	// Auto Scaling. If the output does contain data, AWS CodeDeploy could not remove
	// some Auto Scaling lifecycle event hooks from the instances in the Auto Scaling
	// group.
	HooksNotCleanedUp []*AutoScalingGroup `locationName:"hooksNotCleanedUp" type:"list"`

	metadataDeleteDeploymentGroupOutput `json:"-" xml:"-"`
}

type metadataDeleteDeploymentGroupOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about a deployment configuration.
type DeploymentConfigInfo struct {
	// The time that the deployment configuration was created.
	CreateTime *time.Time `locationName:"createTime" type:"timestamp" timestampFormat:"unix"`

	// The deployment configuration ID.
	DeploymentConfigID *string `locationName:"deploymentConfigId" type:"string"`

	// The deployment configuration name.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string"`

	// Information about the number or percentage of minimum healthy instances.
	MinimumHealthyHosts *MinimumHealthyHosts `locationName:"minimumHealthyHosts" type:"structure"`

	metadataDeploymentConfigInfo `json:"-" xml:"-"`
}

type metadataDeploymentConfigInfo struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about a deployment group.
type DeploymentGroupInfo struct {
	// The application name.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// A list of associated Auto Scaling groups.
	AutoScalingGroups []*AutoScalingGroup `locationName:"autoScalingGroups" type:"list"`

	// The deployment configuration name.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string"`

	// The deployment group ID.
	DeploymentGroupID *string `locationName:"deploymentGroupId" type:"string"`

	// The deployment group name.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string"`

	// The Amazon EC2 tags to filter on.
	EC2TagFilters []*EC2TagFilter `locationName:"ec2TagFilters" type:"list"`

	// A service role ARN.
	ServiceRoleARN *string `locationName:"serviceRoleArn" type:"string"`

	// Information about the deployment group's target revision, including the revision's
	// type and its location.
	TargetRevision *RevisionLocation `locationName:"targetRevision" type:"structure"`

	metadataDeploymentGroupInfo `json:"-" xml:"-"`
}

type metadataDeploymentGroupInfo struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about a deployment.
type DeploymentInfo struct {
	// The application name.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// A timestamp indicating when the deployment was completed.
	CompleteTime *time.Time `locationName:"completeTime" type:"timestamp" timestampFormat:"unix"`

	// A timestamp indicating when the deployment was created.
	CreateTime *time.Time `locationName:"createTime" type:"timestamp" timestampFormat:"unix"`

	// How the deployment was created:
	//
	//  user: A user created the deployment. autoscaling: Auto Scaling created
	// the deployment.
	Creator *string `locationName:"creator" type:"string"`

	// The deployment configuration name.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string"`

	// The deployment group name.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string"`

	// The deployment ID.
	DeploymentID *string `locationName:"deploymentId" type:"string"`

	// A summary of the deployment status of the instances in the deployment.
	DeploymentOverview *DeploymentOverview `locationName:"deploymentOverview" type:"structure"`

	// A comment about the deployment.
	Description *string `locationName:"description" type:"string"`

	// Information about any error associated with this deployment.
	ErrorInformation *ErrorInformation `locationName:"errorInformation" type:"structure"`

	// If true, then if the deployment causes the ApplicationStop deployment lifecycle
	// event to fail to a specific instance, the deployment will not be considered
	// to have failed to that instance at that point and will continue on to the
	// BeforeInstall deployment lifecycle event.
	//
	// If false or not specified, then if the deployment causes the ApplicationStop
	// deployment lifecycle event to fail to a specific instance, the deployment
	// will stop to that instance, and the deployment to that instance will be considered
	// to have failed.
	IgnoreApplicationStopFailures *bool `locationName:"ignoreApplicationStopFailures" type:"boolean"`

	// Information about the location of application artifacts that are stored and
	// the service to retrieve them from.
	Revision *RevisionLocation `locationName:"revision" type:"structure"`

	// A timestamp indicating when the deployment began deploying to the deployment
	// group.
	//
	// Note that in some cases, the reported value of the start time may be later
	// than the complete time. This is due to differences in the clock settings
	// of various back-end servers that participate in the overall deployment process.
	StartTime *time.Time `locationName:"startTime" type:"timestamp" timestampFormat:"unix"`

	// The current state of the deployment as a whole.
	Status *string `locationName:"status" type:"string"`

	metadataDeploymentInfo `json:"-" xml:"-"`
}

type metadataDeploymentInfo struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about the deployment status of the instances in the deployment.
type DeploymentOverview struct {
	// The number of instances that have failed in the deployment.
	Failed *int64 `type:"long"`

	// The number of instances that are in progress in the deployment.
	InProgress *int64 `type:"long"`

	// The number of instances that are pending in the deployment.
	Pending *int64 `type:"long"`

	// The number of instances that have been skipped in the deployment.
	Skipped *int64 `type:"long"`

	// The number of instances that have succeeded in the deployment.
	Succeeded *int64 `type:"long"`

	metadataDeploymentOverview `json:"-" xml:"-"`
}

type metadataDeploymentOverview struct {
	SDKShapeTraits bool `type:"structure"`
}

// Diagnostic information about executable scripts that are part of a deployment.
type Diagnostics struct {
	// The associated error code:
	//
	//  Success: The specified script ran. ScriptMissing: The specified script
	// was not found in the specified location. ScriptNotExecutable: The specified
	// script is not a recognized executable file type. ScriptTimedOut: The specified
	// script did not finish running in the specified time period. ScriptFailed:
	// The specified script failed to run as expected. UnknownError: The specified
	// script did not run for an unknown reason.
	ErrorCode *string `locationName:"errorCode" type:"string"`

	// The last portion of the associated diagnostic log.
	LogTail *string `locationName:"logTail" type:"string"`

	// The message associated with the error.
	Message *string `locationName:"message" type:"string"`

	// The name of the script.
	ScriptName *string `locationName:"scriptName" type:"string"`

	metadataDiagnostics `json:"-" xml:"-"`
}

type metadataDiagnostics struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about an Amazon EC2 tag filter.
type EC2TagFilter struct {
	// The Amazon EC2 tag filter key.
	Key *string `type:"string"`

	// The Amazon EC2 tag filter type:
	//
	//  KEY_ONLY: Key only. VALUE_ONLY: Value only. KEY_AND_VALUE: Key and value.
	Type *string `type:"string"`

	// The Amazon EC2 tag filter value.
	Value *string `type:"string"`

	metadataEC2TagFilter `json:"-" xml:"-"`
}

type metadataEC2TagFilter struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about a deployment error.
type ErrorInformation struct {
	// The error code:
	//
	//  APPLICATION_MISSING: The application was missing. Note that this error
	// code will most likely be raised if the application is deleted after the deployment
	// is created but before it starts. DEPLOYMENT_GROUP_MISSING: The deployment
	// group was missing. Note that this error code will most likely be raised if
	// the deployment group is deleted after the deployment is created but before
	// it starts. REVISION_MISSING: The revision ID was missing. Note that this
	// error code will most likely be raised if the revision is deleted after the
	// deployment is created but before it starts. IAM_ROLE_MISSING: The service
	// role cannot be accessed. IAM_ROLE_PERMISSIONS: The service role does not
	// have the correct permissions. OVER_MAX_INSTANCES: The maximum number of instances
	// was exceeded. NO_INSTANCES: No instances were specified, or no instances
	// can be found. TIMEOUT: The deployment has timed out. HEALTH_CONSTRAINTS_INVALID:
	// The revision can never successfully deploy under the instance health constraints
	// as specified. HEALTH_CONSTRAINTS: The deployment failed on too many instances
	// to be able to successfully deploy under the specified instance health constraints.
	// INTERNAL_ERROR: There was an internal error.
	Code *string `locationName:"code" type:"string"`

	// An accompanying error message.
	Message *string `locationName:"message" type:"string"`

	metadataErrorInformation `json:"-" xml:"-"`
}

type metadataErrorInformation struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about an application revision.
type GenericRevisionInfo struct {
	// A list of deployment groups that use this revision.
	DeploymentGroups []*string `locationName:"deploymentGroups" type:"list"`

	// A comment about the revision.
	Description *string `locationName:"description" type:"string"`

	// When the revision was first used by AWS CodeDeploy.
	FirstUsedTime *time.Time `locationName:"firstUsedTime" type:"timestamp" timestampFormat:"unix"`

	// When the revision was last used by AWS CodeDeploy.
	LastUsedTime *time.Time `locationName:"lastUsedTime" type:"timestamp" timestampFormat:"unix"`

	// When the revision was registered with AWS CodeDeploy.
	RegisterTime *time.Time `locationName:"registerTime" type:"timestamp" timestampFormat:"unix"`

	metadataGenericRevisionInfo `json:"-" xml:"-"`
}

type metadataGenericRevisionInfo struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a get application operation.
type GetApplicationInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	metadataGetApplicationInput `json:"-" xml:"-"`
}

type metadataGetApplicationInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a get application operation.
type GetApplicationOutput struct {
	// Information about the application.
	Application *ApplicationInfo `locationName:"application" type:"structure"`

	metadataGetApplicationOutput `json:"-" xml:"-"`
}

type metadataGetApplicationOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a get application revision operation.
type GetApplicationRevisionInput struct {
	// The name of the application that corresponds to the revision.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// Information about the application revision to get, including the revision's
	// type and its location.
	Revision *RevisionLocation `locationName:"revision" type:"structure" required:"true"`

	metadataGetApplicationRevisionInput `json:"-" xml:"-"`
}

type metadataGetApplicationRevisionInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a get application revision operation.
type GetApplicationRevisionOutput struct {
	// The name of the application that corresponds to the revision.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// Additional information about the revision, including the revision's type
	// and its location.
	Revision *RevisionLocation `locationName:"revision" type:"structure"`

	// General information about the revision.
	RevisionInfo *GenericRevisionInfo `locationName:"revisionInfo" type:"structure"`

	metadataGetApplicationRevisionOutput `json:"-" xml:"-"`
}

type metadataGetApplicationRevisionOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a get deployment configuration operation.
type GetDeploymentConfigInput struct {
	// The name of an existing deployment configuration within the AWS user account.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string" required:"true"`

	metadataGetDeploymentConfigInput `json:"-" xml:"-"`
}

type metadataGetDeploymentConfigInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a get deployment configuration operation.
type GetDeploymentConfigOutput struct {
	// Information about the deployment configuration.
	DeploymentConfigInfo *DeploymentConfigInfo `locationName:"deploymentConfigInfo" type:"structure"`

	metadataGetDeploymentConfigOutput `json:"-" xml:"-"`
}

type metadataGetDeploymentConfigOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a get deployment group operation.
type GetDeploymentGroupInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// The name of an existing deployment group for the specified application.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string" required:"true"`

	metadataGetDeploymentGroupInput `json:"-" xml:"-"`
}

type metadataGetDeploymentGroupInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a get deployment group operation.
type GetDeploymentGroupOutput struct {
	// Information about the deployment group.
	DeploymentGroupInfo *DeploymentGroupInfo `locationName:"deploymentGroupInfo" type:"structure"`

	metadataGetDeploymentGroupOutput `json:"-" xml:"-"`
}

type metadataGetDeploymentGroupOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a get deployment operation.
type GetDeploymentInput struct {
	// An existing deployment ID within the AWS user account.
	DeploymentID *string `locationName:"deploymentId" type:"string" required:"true"`

	metadataGetDeploymentInput `json:"-" xml:"-"`
}

type metadataGetDeploymentInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a get deployment instance operation.
type GetDeploymentInstanceInput struct {
	// The unique ID of a deployment.
	DeploymentID *string `locationName:"deploymentId" type:"string" required:"true"`

	// The unique ID of an Amazon EC2 instance in the deployment's deployment group.
	InstanceID *string `locationName:"instanceId" type:"string" required:"true"`

	metadataGetDeploymentInstanceInput `json:"-" xml:"-"`
}

type metadataGetDeploymentInstanceInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a get deployment instance operation.
type GetDeploymentInstanceOutput struct {
	// Information about the instance.
	InstanceSummary *InstanceSummary `locationName:"instanceSummary" type:"structure"`

	metadataGetDeploymentInstanceOutput `json:"-" xml:"-"`
}

type metadataGetDeploymentInstanceOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a get deployment operation.
type GetDeploymentOutput struct {
	// Information about the deployment.
	DeploymentInfo *DeploymentInfo `locationName:"deploymentInfo" type:"structure"`

	metadataGetDeploymentOutput `json:"-" xml:"-"`
}

type metadataGetDeploymentOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about the location of application artifacts that are stored in
// GitHub.
type GitHubLocation struct {
	// The SHA1 commit ID of the GitHub commit that references the that represents
	// the bundled artifacts for the application revision.
	CommitID *string `locationName:"commitId" type:"string"`

	// The GitHub account and repository pair that stores a reference to the commit
	// that represents the bundled artifacts for the application revision.
	//
	// Specified as account/repository.
	Repository *string `locationName:"repository" type:"string"`

	metadataGitHubLocation `json:"-" xml:"-"`
}

type metadataGitHubLocation struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about an Amazon EC2 instance in a deployment.
type InstanceSummary struct {
	// The deployment ID.
	DeploymentID *string `locationName:"deploymentId" type:"string"`

	// The instance ID.
	InstanceID *string `locationName:"instanceId" type:"string"`

	// A timestamp indicating when the instance information was last updated.
	LastUpdatedAt *time.Time `locationName:"lastUpdatedAt" type:"timestamp" timestampFormat:"unix"`

	// A list of lifecycle events for this instance.
	LifecycleEvents []*LifecycleEvent `locationName:"lifecycleEvents" type:"list"`

	// The deployment status for this instance:
	//
	//  Pending: The deployment is pending for this instance. In Progress: The
	// deployment is in progress for this instance. Succeeded: The deployment has
	// succeeded for this instance. Failed: The deployment has failed for this instance.
	// Skipped: The deployment has been skipped for this instance. Unknown: The
	// deployment status is unknown for this instance.
	Status *string `locationName:"status" type:"string"`

	metadataInstanceSummary `json:"-" xml:"-"`
}

type metadataInstanceSummary struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about a deployment lifecycle event.
type LifecycleEvent struct {
	// Diagnostic information about the deployment lifecycle event.
	Diagnostics *Diagnostics `locationName:"diagnostics" type:"structure"`

	// A timestamp indicating when the deployment lifecycle event ended.
	EndTime *time.Time `locationName:"endTime" type:"timestamp" timestampFormat:"unix"`

	// The deployment lifecycle event name, such as ApplicationStop, BeforeInstall,
	// AfterInstall, ApplicationStart, or ValidateService.
	LifecycleEventName *string `locationName:"lifecycleEventName" type:"string"`

	// A timestamp indicating when the deployment lifecycle event started.
	StartTime *time.Time `locationName:"startTime" type:"timestamp" timestampFormat:"unix"`

	// The deployment lifecycle event status:
	//
	//  Pending: The deployment lifecycle event is pending. InProgress: The deployment
	// lifecycle event is in progress. Succeeded: The deployment lifecycle event
	// has succeeded. Failed: The deployment lifecycle event has failed. Skipped:
	// The deployment lifecycle event has been skipped. Unknown: The deployment
	// lifecycle event is unknown.
	Status *string `locationName:"status" type:"string"`

	metadataLifecycleEvent `json:"-" xml:"-"`
}

type metadataLifecycleEvent struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a list application revisions operation.
type ListApplicationRevisionsInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// Whether to list revisions based on whether the revision is the target revision
	// of an deployment group:
	//
	//  include: List revisions that are target revisions of a deployment group.
	// exclude: Do not list revisions that are target revisions of a deployment
	// group. ignore: List all revisions, regardless of whether they are target
	// revisions of a deployment group.
	Deployed *string `locationName:"deployed" type:"string"`

	// An identifier that was returned from the previous list application revisions
	// call, which can be used to return the next set of applications in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	// A specific Amazon S3 bucket name to limit the search for revisions.
	//
	// If set to null, then all of the user's buckets will be searched.
	S3Bucket *string `locationName:"s3Bucket" type:"string"`

	// A specific key prefix for the set of Amazon S3 objects to limit the search
	// for revisions.
	S3KeyPrefix *string `locationName:"s3KeyPrefix" type:"string"`

	// The column name to sort the list results by:
	//
	//  registerTime: Sort the list results by when the revisions were registered
	// with AWS CodeDeploy. firstUsedTime: Sort the list results by when the revisions
	// were first used by in a deployment. lastUsedTime: Sort the list results by
	// when the revisions were last used in a deployment.  If not specified or set
	// to null, the results will be returned in an arbitrary order.
	SortBy *string `locationName:"sortBy" type:"string"`

	// The order to sort the list results by:
	//
	//  ascending: Sort the list results in ascending order. descending: Sort the
	// list results in descending order.  If not specified, the results will be
	// sorted in ascending order.
	//
	// If set to null, the results will be sorted in an arbitrary order.
	SortOrder *string `locationName:"sortOrder" type:"string"`

	metadataListApplicationRevisionsInput `json:"-" xml:"-"`
}

type metadataListApplicationRevisionsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a list application revisions operation.
type ListApplicationRevisionsOutput struct {
	// If the amount of information that is returned is significantly large, an
	// identifier will also be returned, which can be used in a subsequent list
	// application revisions call to return the next set of application revisions
	// in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	// A list of revision locations that contain the matching revisions.
	Revisions []*RevisionLocation `locationName:"revisions" type:"list"`

	metadataListApplicationRevisionsOutput `json:"-" xml:"-"`
}

type metadataListApplicationRevisionsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a list applications operation.
type ListApplicationsInput struct {
	// An identifier that was returned from the previous list applications call,
	// which can be used to return the next set of applications in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListApplicationsInput `json:"-" xml:"-"`
}

type metadataListApplicationsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a list applications operation.
type ListApplicationsOutput struct {
	// A list of application names.
	Applications []*string `locationName:"applications" type:"list"`

	// If the amount of information that is returned is significantly large, an
	// identifier will also be returned, which can be used in a subsequent list
	// applications call to return the next set of applications in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListApplicationsOutput `json:"-" xml:"-"`
}

type metadataListApplicationsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a list deployment configurations operation.
type ListDeploymentConfigsInput struct {
	// An identifier that was returned from the previous list deployment configurations
	// call, which can be used to return the next set of deployment configurations
	// in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentConfigsInput `json:"-" xml:"-"`
}

type metadataListDeploymentConfigsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a list deployment configurations operation.
type ListDeploymentConfigsOutput struct {
	// A list of deployment configurations, including the built-in configurations
	// such as CodeDeployDefault.OneAtATime.
	DeploymentConfigsList []*string `locationName:"deploymentConfigsList" type:"list"`

	// If the amount of information that is returned is significantly large, an
	// identifier will also be returned, which can be used in a subsequent list
	// deployment configurations call to return the next set of deployment configurations
	// in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentConfigsOutput `json:"-" xml:"-"`
}

type metadataListDeploymentConfigsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a list deployment groups operation.
type ListDeploymentGroupsInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// An identifier that was returned from the previous list deployment groups
	// call, which can be used to return the next set of deployment groups in the
	// list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentGroupsInput `json:"-" xml:"-"`
}

type metadataListDeploymentGroupsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a list deployment groups operation.
type ListDeploymentGroupsOutput struct {
	// The application name.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// A list of corresponding deployment group names.
	DeploymentGroups []*string `locationName:"deploymentGroups" type:"list"`

	// If the amount of information that is returned is significantly large, an
	// identifier will also be returned, which can be used in a subsequent list
	// deployment groups call to return the next set of deployment groups in the
	// list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentGroupsOutput `json:"-" xml:"-"`
}

type metadataListDeploymentGroupsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a list deployment instances operation.
type ListDeploymentInstancesInput struct {
	// The unique ID of a deployment.
	DeploymentID *string `locationName:"deploymentId" type:"string" required:"true"`

	// A subset of instances to list, by status:
	//
	//  Pending: Include in the resulting list those instances with pending deployments.
	// InProgress: Include in the resulting list those instances with in-progress
	// deployments. Succeeded: Include in the resulting list those instances with
	// succeeded deployments. Failed: Include in the resulting list those instances
	// with failed deployments. Skipped: Include in the resulting list those instances
	// with skipped deployments. Unknown: Include in the resulting list those instances
	// with deployments in an unknown state.
	InstanceStatusFilter []*string `locationName:"instanceStatusFilter" type:"list"`

	// An identifier that was returned from the previous list deployment instances
	// call, which can be used to return the next set of deployment instances in
	// the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentInstancesInput `json:"-" xml:"-"`
}

type metadataListDeploymentInstancesInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a list deployment instances operation.
type ListDeploymentInstancesOutput struct {
	// A list of instance IDs.
	InstancesList []*string `locationName:"instancesList" type:"list"`

	// If the amount of information that is returned is significantly large, an
	// identifier will also be returned, which can be used in a subsequent list
	// deployment instances call to return the next set of deployment instances
	// in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentInstancesOutput `json:"-" xml:"-"`
}

type metadataListDeploymentInstancesOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a list deployments operation.
type ListDeploymentsInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// A deployment creation start- and end-time range for returning a subset of
	// the list of deployments.
	CreateTimeRange *TimeRange `locationName:"createTimeRange" type:"structure"`

	// The name of an existing deployment group for the specified application.
	DeploymentGroupName *string `locationName:"deploymentGroupName" type:"string"`

	// A subset of deployments to list, by status:  Created: Include in the resulting
	// list created deployments. Queued: Include in the resulting list queued deployments.
	// In Progress: Include in the resulting list in-progress deployments. Succeeded:
	// Include in the resulting list succeeded deployments. Failed: Include in the
	// resulting list failed deployments. Aborted: Include in the resulting list
	// aborted deployments.
	IncludeOnlyStatuses []*string `locationName:"includeOnlyStatuses" type:"list"`

	// An identifier that was returned from the previous list deployments call,
	// which can be used to return the next set of deployments in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentsInput `json:"-" xml:"-"`
}

type metadataListDeploymentsInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a list deployments operation.
type ListDeploymentsOutput struct {
	// A list of deployment IDs.
	Deployments []*string `locationName:"deployments" type:"list"`

	// If the amount of information that is returned is significantly large, an
	// identifier will also be returned, which can be used in a subsequent list
	// deployments call to return the next set of deployments in the list.
	NextToken *string `locationName:"nextToken" type:"string"`

	metadataListDeploymentsOutput `json:"-" xml:"-"`
}

type metadataListDeploymentsOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about minimum healthy instances.
type MinimumHealthyHosts struct {
	// The minimum healthy instances type:
	//
	//  HOST_COUNT: The minimum number of healthy instances, as an absolute value.
	// FLEET_PERCENT: The minimum number of healthy instances, as a percentage of
	// the total number of instances in the deployment.  For example, for 9 Amazon
	// EC2 instances, if a HOST_COUNT of 6 is specified, deploy to up to 3 instances
	// at a time. The deployment succeeds if 6 or more instances are successfully
	// deployed to; otherwise, the deployment fails. If a FLEET_PERCENT of 40 is
	// specified, deploy to up to 5 instances at a time. The deployment succeeds
	// if 4 or more instances are successfully deployed to; otherwise, the deployment
	// fails.
	//
	// In a call to the get deployment configuration operation, CodeDeployDefault.OneAtATime
	// will return a minimum healthy instances type of MOST_CONCURRENCY and a value
	// of 1. This means a deployment to only one Amazon EC2 instance at a time.
	// (You cannot set the type to MOST_CONCURRENCY, only to HOST_COUNT or FLEET_PERCENT.)
	Type *string `locationName:"type" type:"string"`

	// The minimum healthy instances value.
	Value *int64 `locationName:"value" type:"integer"`

	metadataMinimumHealthyHosts `json:"-" xml:"-"`
}

type metadataMinimumHealthyHosts struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a register application revision operation.
type RegisterApplicationRevisionInput struct {
	// The name of an existing AWS CodeDeploy application within the AWS user account.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// A comment about the revision.
	Description *string `locationName:"description" type:"string"`

	// Information about the application revision to register, including the revision's
	// type and its location.
	Revision *RevisionLocation `locationName:"revision" type:"structure" required:"true"`

	metadataRegisterApplicationRevisionInput `json:"-" xml:"-"`
}

type metadataRegisterApplicationRevisionInput struct {
	SDKShapeTraits bool `type:"structure"`
}

type RegisterApplicationRevisionOutput struct {
	metadataRegisterApplicationRevisionOutput `json:"-" xml:"-"`
}

type metadataRegisterApplicationRevisionOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about an application revision's location.
type RevisionLocation struct {
	// Information about the location of application artifacts that are stored in
	// GitHub.
	GitHubLocation *GitHubLocation `locationName:"gitHubLocation" type:"structure"`

	// The application revision's type:
	//
	//  S3: An application revision stored in Amazon S3. GitHub: An application
	// revision stored in GitHub.
	RevisionType *string `locationName:"revisionType" type:"string"`

	// Information about the location of application artifacts that are stored in
	// Amazon S3.
	S3Location *S3Location `locationName:"s3Location" type:"structure"`

	metadataRevisionLocation `json:"-" xml:"-"`
}

type metadataRevisionLocation struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about the location of application artifacts that are stored in
// Amazon S3.
type S3Location struct {
	// The name of the Amazon S3 bucket where the application revision is stored.
	Bucket *string `locationName:"bucket" type:"string"`

	// The file type of the application revision. Must be one of the following:
	//
	//  tar: A tar archive file. tgz: A compressed tar archive file. zip: A zip
	// archive file.
	BundleType *string `locationName:"bundleType" type:"string"`

	// The ETag of the Amazon S3 object that represents the bundled artifacts for
	// the application revision.
	//
	// If the ETag is not specified as an input parameter, ETag validation of the
	// object will be skipped.
	ETag *string `locationName:"eTag" type:"string"`

	// The name of the Amazon S3 object that represents the bundled artifacts for
	// the application revision.
	Key *string `locationName:"key" type:"string"`

	// A specific version of the Amazon S3 object that represents the bundled artifacts
	// for the application revision.
	//
	// If the version is not specified, the system will use the most recent version
	// by default.
	Version *string `locationName:"version" type:"string"`

	metadataS3Location `json:"-" xml:"-"`
}

type metadataS3Location struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of a stop deployment operation.
type StopDeploymentInput struct {
	// The unique ID of a deployment.
	DeploymentID *string `locationName:"deploymentId" type:"string" required:"true"`

	metadataStopDeploymentInput `json:"-" xml:"-"`
}

type metadataStopDeploymentInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of a stop deployment operation.
type StopDeploymentOutput struct {
	// The status of the stop deployment operation:
	//
	//  Pending: The stop operation is pending. Succeeded: The stop operation succeeded.
	Status *string `locationName:"status" type:"string"`

	// An accompanying status message.
	StatusMessage *string `locationName:"statusMessage" type:"string"`

	metadataStopDeploymentOutput `json:"-" xml:"-"`
}

type metadataStopDeploymentOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Information about a time range.
type TimeRange struct {
	// The time range's end time.
	//
	// Specify null to leave the time range's end time open-ended.
	End *time.Time `locationName:"end" type:"timestamp" timestampFormat:"unix"`

	// The time range's start time.
	//
	// Specify null to leave the time range's start time open-ended.
	Start *time.Time `locationName:"start" type:"timestamp" timestampFormat:"unix"`

	metadataTimeRange `json:"-" xml:"-"`
}

type metadataTimeRange struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of an update application operation.
type UpdateApplicationInput struct {
	// The current name of the application that you want to change.
	ApplicationName *string `locationName:"applicationName" type:"string"`

	// The new name that you want to change the application to.
	NewApplicationName *string `locationName:"newApplicationName" type:"string"`

	metadataUpdateApplicationInput `json:"-" xml:"-"`
}

type metadataUpdateApplicationInput struct {
	SDKShapeTraits bool `type:"structure"`
}

type UpdateApplicationOutput struct {
	metadataUpdateApplicationOutput `json:"-" xml:"-"`
}

type metadataUpdateApplicationOutput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the input of an update deployment group operation.
type UpdateDeploymentGroupInput struct {
	// The application name corresponding to the deployment group to update.
	ApplicationName *string `locationName:"applicationName" type:"string" required:"true"`

	// The replacement list of Auto Scaling groups to be included in the deployment
	// group, if you want to change them.
	AutoScalingGroups []*string `locationName:"autoScalingGroups" type:"list"`

	// The current name of the existing deployment group.
	CurrentDeploymentGroupName *string `locationName:"currentDeploymentGroupName" type:"string" required:"true"`

	// The replacement deployment configuration name to use, if you want to change
	// it.
	DeploymentConfigName *string `locationName:"deploymentConfigName" type:"string"`

	// The replacement set of Amazon EC2 tags to filter on, if you want to change
	// them.
	EC2TagFilters []*EC2TagFilter `locationName:"ec2TagFilters" type:"list"`

	// The new name of the deployment group, if you want to change it.
	NewDeploymentGroupName *string `locationName:"newDeploymentGroupName" type:"string"`

	// A replacement service role's ARN, if you want to change it.
	ServiceRoleARN *string `locationName:"serviceRoleArn" type:"string"`

	metadataUpdateDeploymentGroupInput `json:"-" xml:"-"`
}

type metadataUpdateDeploymentGroupInput struct {
	SDKShapeTraits bool `type:"structure"`
}

// Represents the output of an update deployment group operation.
type UpdateDeploymentGroupOutput struct {
	// If the output contains no data, and the corresponding deployment group contained
	// at least one Auto Scaling group, AWS CodeDeploy successfully removed all
	// corresponding Auto Scaling lifecycle event hooks from the AWS user account.
	// If the output does contain data, AWS CodeDeploy could not remove some Auto
	// Scaling lifecycle event hooks from the AWS user account.
	HooksNotCleanedUp []*AutoScalingGroup `locationName:"hooksNotCleanedUp" type:"list"`

	metadataUpdateDeploymentGroupOutput `json:"-" xml:"-"`
}

type metadataUpdateDeploymentGroupOutput struct {
	SDKShapeTraits bool `type:"structure"`
}